#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QDebug>
#include <QMessageBox>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    //liaison MQTT
    client.setHostname("10.98.9.20");
    client.setPort(1883);
    client.connectToHost();

    //reception capteurs
    connect(&client,SIGNAL(connected()),this,SLOT(connecte()));
    connect(&client,SIGNAL(messageReceived(QByteArray,QMqttTopicName)),this,SLOT(messageRecu(QByteArray,QMqttTopicName)));
    connect(this,SIGNAL(valueChanged(bool)),this,SLOT(change(bool)));

    connect(this,SIGNAL(valueChanged(bool)),this,SLOT(DepCpt(bool)));
    //management supervision machine
        //Appui sur le bouton "page precedente" décremente n
        connect(ui->previous,SIGNAL(clicked()),this,SLOT(pPreced()));
        //Appui sur le bouton "page suivante" incremente n
        connect(ui->next,SIGNAL(clicked()),this,SLOT(pSuivante()));
        //la nouvelle valeur de n est envoyé à la fct "changerPage"
        connect(this,SIGNAL(valueChanged(int)),this,SLOT(changerPage(int)));


}


MainWindow::~MainWindow()
{
    delete ui;
}

//description pour liaison MQTT
void MainWindow::connecte()
{
    qDebug() <<"i'm connected";
    qDebug() <<"current state flick= "<<flick;

    //topic auquel vous êtes souscrit
    subscription = client.subscribe(QLatin1String("cptE15"));
    if(!subscription)
    {
        QMessageBox::critical(this,"error","failed to connect to broker");
        return;
    }
    ui->tabWidget->setCurrentIndex(0);
}

void MainWindow::convoyeurOFF()
{
    qDebug() <<"arrêt convoyeur";
    QByteArray message = "1";
    quint8 qos = 1;               
    client.publish(QLatin1String("relais"),message,qos);
    flick=false;
    qDebug() << "flick = "<< flick;

    if(flick == false){
    ui->enArret->setStyleSheet("background-color:red");
    ui->enMarche->setStyleSheet("background-color:");
    ui->posteAuto->setStyleSheet("background-color:");

    }
}

void MainWindow::convoyeurON()
{

    qDebug() <<"demarrage convoyeur";
    QByteArray message = "0";
    quint8 qos = 1;
    client.publish(QLatin1String("relais"),message,qos);
    flick=true;
    qDebug() << "flick = " << flick;

    if(flick == true){
    ui->enMarche->setStyleSheet("background-color:green");
    ui->enArret->setStyleSheet("background-color:");
     ui->posteAuto->setStyleSheet("background-color:orange");
    }
}

void MainWindow::change(bool state)
{
    qDebug() << "atteint";
  if(state == false)
  {
     ui->cptE47->setStyleSheet("background-color:orange");
  }
  else if(state == true)
  {
     ui->cptE47->setStyleSheet("background-color:black");
  }
}



void MainWindow::deconnecte()
{
    QMessageBox::critical(this,"information","broker deconnection");

}

void MainWindow::messageRecu(const QByteArray &message, const QMqttTopicName &topic)
{
    qDebug() << QDateTime::currentDateTime().toString() << topic.name() << message;

    trmt=!trmt;
    qDebug() << trmt;
    emit valueChanged(trmt);
    monTimer.setInterval(1000);
    monTimer.start();
    connect(&monTimer,SIGNAL(timeout()),this,SLOT(relaisOFF()));
    //monTimer.stop();
}

//description pour fonction gerant la supervision de la machine
void MainWindow::changerPage(int index)
{
    qDebug()<<index;
    ui->tabWidget->setCurrentIndex(index);
}

void MainWindow::pSuivante()
{
    //qDebug()<<"forward";
    n=n+1;
    //qDebug()<<n;

    if(n>nbPages){
        n=nbPages;
    }

    //emet la nouvelle valeur de n
    emit valueChanged(n);
}

void MainWindow::pPreced()
{
    //qDebug()<<"backward";
    n=n-1;
    //qDebug()<<n;
    if(n<0){
        n=0;
    }

    //emet la nouvelle valeur de n
    emit valueChanged(n);
}

void MainWindow::Robot()
{
    qDebug() <<"démarrage cycle bras robot ";
    ui->startCy->setStyleSheet("background-color:orange");
    QByteArray message = "0";
    quint8 qos = 1;
    client.publish(QLatin1String("robot"),message,qos);
}

void MainWindow::PMOFF()
{
    qDebug() <<"moteur du poste manuel 3 à l'arrêt";
    QByteArray message = "1";
    quint8 qos = 1;
    client.publish(QLatin1String("convPM"),message,qos);
    ui->OffPM->setStyleSheet("background-color:red");
    ui->OnPM->setStyleSheet("background-color:");
    ui->posteManuel3->setStyleSheet("background-color:");

}

void MainWindow::PMON()
{
    qDebug() <<"moteur du poste manuel 3 en marche";
    QByteArray message = "0";
    quint8 qos = 1;
    client.publish(QLatin1String("convPM"),message,qos);
    ui->OnPM->setStyleSheet("background-color:green");
    ui->OffPM->setStyleSheet("background-color:");
    ui->posteManuel3->setStyleSheet("background-color:orange");
}

//verin stoppeur entrée poste manuel
void MainWindow::InVerStopMan()
{
    qDebug() <<"entrée verin stoppeur poste manuel";
    QByteArray message = "0";
    quint8 qos = 1;
    client.publish(QLatin1String("verinSMIN"),message,qos);
    QByteArray message2 = "1";
    quint8 qos2 = 1;
    client.publish(QLatin1String("verinSMOUT"),message2,qos2);
    ui->INvsm->setStyleSheet("background-color:red");
    ui->OUTvsm->setStyleSheet("background-color:");
    // code couleur entrée verin stoppeur vers poste manuel
    ui->verStopMan->setStyleSheet("background-color:red");
}

void MainWindow::OutVerStopMan()
{
    qDebug() <<"sortie verin stoppeur poste manuel";
    QByteArray message = "0";
    quint8 qos = 1;
    client.publish(QLatin1String("verinSMOUT"),message,qos);
    ui->OUTvsm->setStyleSheet("background-color:green");
    ui->INvsm->setStyleSheet("background-color:");
    QByteArray message2 = "1";
    quint8 qos2 = 1;
    client.publish(QLatin1String("verinSMIN"),message2,qos2);
    // code couleur sortie verin stoppeur vers poste manuel
    ui->verStopMan->setStyleSheet("background-color:green");
}

//verin aiguillage entrée poste manuel
void MainWindow::InAigMan()
{
    qDebug() <<"entrée verin aiguillage poste manuel";
    QByteArray message = "1";
    quint8 qos = 1;
    client.publish(QLatin1String("aiguillageMIN"),message,qos);
    QByteArray message2 = "0";
    quint8 qos2 = 1;
    client.publish(QLatin1String("aiguillageMOUT"),message2,qos2);
    ui->INam->setStyleSheet("background-color:red");
    ui->OUTam->setStyleSheet("background-color:");
    // code couleur aiguilage vers poste manuel
    ui->AigEntreePM->setStyleSheet("background-color:red");
}

void MainWindow::OutAigMan()
{
    qDebug() <<"sortie verin aiguillage poste manuel";
    QByteArray message = "1";
    quint8 qos = 1;
    client.publish(QLatin1String("aiguillageMOUT"),message,qos);
    QByteArray message2 = "0";
    quint8 qos2 = 1;
    client.publish(QLatin1String("aiguillageMIN"),message2,qos2);
    ui->INam->setStyleSheet("background-color:");
    ui->OUTam->setStyleSheet("background-color:green");
    // code couleur aiguillage vers poste auto
    ui->AigEntreePM->setStyleSheet("background-color:green");
}

//verin stoppeur entrée poste auto
void MainWindow::InVerStopAut()
{
    qDebug() <<"entrée verin stoppeur poste auto";
    QByteArray message = "1";
    quint8 qos = 1;
    client.publish(QLatin1String("verinSAIN"),message,qos);
    QByteArray message2 = "0";
    quint8 qos2 = 1;
    client.publish(QLatin1String("verinSAOUT"),message2,qos2);
    ui->INvsa->setStyleSheet("background-color:red");
    ui->OUTvsa->setStyleSheet("background-color:");
}

void MainWindow::OutVerStopAut()
{
    qDebug() <<"sortie verin stoppeur poste auto";
    QByteArray message = "1";
    quint8 qos = 1;
    client.publish(QLatin1String("verinSAOUT"),message,qos);
    QByteArray message2 = "0";
    quint8 qos2 = 1;
    client.publish(QLatin1String("verinSAIN"),message2,qos2);
    ui->OUTvsa->setStyleSheet("background-color:green");
    ui->INvsa->setStyleSheet("background-color:");
}

//verin stoppeur indexage  poste auto
void MainWindow::InVerStopIndAut()
{
    qDebug() <<"entrée verin stoppeur indexage poste auto";
    QByteArray message = "1";
    quint8 qos = 1;
    client.publish(QLatin1String("verinSIAIN"),message,qos);
    QByteArray message2 = "0";
    quint8 qos2 = 1;
    client.publish(QLatin1String("verinSIAOUT"),message2,qos2);
    ui->INvsia->setStyleSheet("background-color:red");
    ui->OUTvsia->setStyleSheet("background-color:");
}

void MainWindow::OutVerStopIndAut()
{
    qDebug() <<"sortie verin stoppeur indexage poste auto";
    QByteArray message = "1";
    quint8 qos = 1;
    client.publish(QLatin1String("verinSIAOUT"),message,qos);
    QByteArray message2 = "0";
    quint8 qos2 = 1;
    client.publish(QLatin1String("verinSIAIN"),message2,qos2);
    ui->OUTvsia->setStyleSheet("background-color:green");
    ui->INvsia->setStyleSheet("background-color:");
}

void MainWindow::DepCpt(bool state)
{
    qDebug() << "dd";

  if(state == false)
  {
     ui->witness->setStyleSheet("background-color:orange");

  }
  else if(state == true)
  {
     ui->witness->setStyleSheet("background-color:black");
  }
}

//DEPANNAGE
void MainWindow::DepActON()
{
    qDebug() <<"publication topic relais à l'état 1";
    QByteArray message = "0";
    quint8 qos = 1;
    client.publish(QLatin1String("relaisDep"),message,qos);
    flick=true;
    qDebug() << "flick = " << flick;

    if(flick == true){
    ui->enMarche->setStyleSheet("background-color:green");
    ui->enArret->setStyleSheet("background-color:");
    }
}

void MainWindow::DepActOFF()
{
    qDebug() <<"publication topic relais à l'état 0";
    QByteArray message = "1";
    quint8 qos = 1;
    client.publish(QLatin1String("relaisDep"),message,qos);
    flick=false;
    qDebug() << "flick = "<< flick;

    if(flick == false){
    ui->enArret->setStyleSheet("background-color:red");
    ui->enMarche->setStyleSheet("background-color:");
    }
}

