#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QtMqtt/QtMqtt>
#include <QtMqtt/QMqttClient>
#include <QTimer>


namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

signals:
    void connected();
    void messageReceived(const QByteArray &, const QMqttTopicName &);
    //concernant le capteur
    void valueChanged(bool state);
    //concernant les pages
    void valueChanged(int newValue);

public slots:
    //pour connexion MQTT
    void connecte();
    void change(bool);
    void deconnecte();
    void messageRecu(const QByteArray &message, const QMqttTopicName &topic);
    //management supervision
    void changerPage(int);
    void pSuivante();
    void pPreced();

    //convoyeur
    void convoyeurOFF();
    void convoyeurON();
    //actionneurs poste 3
        //Bras robot
        void Robot();
        //verin stoppeur entrée poste manuel
        void PMOFF();           //arret moteur poste manuel
        void PMON();            //demarrage moteur poste manuel
        void InVerStopMan();    //A24.6 <=> broche x de la carte nanoPi xxx
        void OutVerStopMan();   //A24.7 <=> broche x de la carte nanoPi xxx
        //verin aiguillage entrée poste manuel
        void InAigMan();    //A25.0 <=> broche 2 de la carte nanoPi 001
        void OutAigMan();   //A25.1 <=> broche 4 de la carte nanoPi 001
        //verin stoppeur entrée poste auto (introuvable)
        void InVerStopAut();    //A16.2 <=> broche x de la carte nanoPi xxx
        void OutVerStopAut();   //A16.3 <=> broche x de la carte nanoPi xxx
        //verin stoppeur indexage  poste auto
        void InVerStopIndAut();    //A16.4 <=> broche x de la carte nanoPi xxx
        void OutVerStopIndAut();   //A16.5 <=> broche x de la carte nanoPi xxx

    //actionneurs poste 2
    //actionneurs poste 1

    //DEPANNAGE
    void DepCpt(bool);
    void DepActON();
    void DepActOFF();

private:
    Ui::MainWindow *ui;
    QMqttClient client;
    QMqttSubscription * subscription;
    QTimer monTimer;
    bool trmt=1;
    bool flick;
    //variables pour poste 3


    int n=0;    //représente le num de la page (page 0 = 1ère page)
    int nbPages=4;  //représente le nb de pages

};

#endif // MAINWINDOW_H
